/*
 * 
 *  dynamic linker command file
 *  generated: Tue Jul  2 14:27:14 2002

 *  kernel   : legOS
 *  app start: 0xa556
 * 
 *  legOS - the independent LEGO Mindstorms OS
 *  (c) 1999 by Markus L. Noga <markus@noga.de>    
 * 
 */

OUTPUT_FORMAT("symbolsrec")
OUTPUT_ARCH(h8300)
ENTRY("_main")

MEMORY {
  rom   : o = 0x0000, l = 0x8000
  kern  : o = 0x8000, l = 0x2556
  ram   : o = 0xa556, l = 0x59a6
  stack : o = 0xfefc, l = 0x0004
  eight : o = 0xff00, l = 0x0100
}

SECTIONS {

  .rom : {
    /* used rom functions */
    
    _rom_reset_vector = 0x0000;
        
    _reset        = 0x03ae ;
    lcd_show      = 0x1b62 ;
    lcd_hide      = 0x1e4a ;
    lcd_number    = 0x1ff2 ;
    lcd_clear     = 0x27ac ;
    power_init    = 0x2964 ;
    sound_system  = 0x299a ;
    power_off     = 0x2a62 ;
    sound_playing = 0x3ccc ;

    _rom_dummy_handler   = 0x046a ;
    _rom_ocia_handler    = 0x04cc ;
    _rom_ocia_return     = 0x04d4 ;
    
  } > rom

  .kernel :	{
    /* kernel symbols (relative to 0x8000) */
    _kmain = 0x0000 ;
    _mm_try_join = 0x00d4 ;
    _mm_update_first_free = 0x0104 ;
    _mm_init = 0x012a ;
    _malloc = 0x01b0 ;
    _free = 0x0256 ;
    _calloc = 0x0280 ;
    _mm_reaper = 0x02a8 ;
    _mm_free_mem = 0x0304 ;
    _systime_handler = 0x0342 ;
    _systime_tm_return = 0x03de ;
    _systime_init = 0x03ee ;
    _systime_shutdown = 0x0438 ;
    _systime_set_switcher = 0x0440 ;
    _systime_set_timeslice = 0x0446 ;
    _tm_switcher = 0x045c ;
    _tm_scheduler = 0x0478 ;
    _yield = 0x063a ;
    _tm_init = 0x0658 ;
    _tm_start = 0x069a ;
    _execi = 0x06aa ;
    _exit = 0x084a ;
    _wait_event = 0x086c ;
    _msleep = 0x08d4 ;
    _sleep = 0x08f6 ;
    _kill = 0x0914 ;
    _killall = 0x0950 ;
    _sem_event_wait = 0x09ba ;
    _sem_wait = 0x09d2 ;
    _sem_trywait = 0x09f2 ;
    _sem_post = 0x0a0a ;
    _delay = 0x0a1a ;
    _cputc_native = 0x0a3a ;
    _cputc_native_0 = 0x0a68 ;
    _cputc_native_1 = 0x0a9c ;
    _cputc_native_2 = 0x0ad2 ;
    _cputc_native_3 = 0x0b0c ;
    _cputc_native_4 = 0x0b48 ;
    _cputc_native_5 = 0x0b84 ;
    _cputw = 0x0b90 ;
    _cputs = 0x0bd4 ;
    _cls = 0x0c1c ;
    _lcd_number = 0x0c26 ;
    _lcd_refresh_next_byte = 0x0cc6 ;
    _lcd_refresh_next_byte_core = 0x0cda ;
    _lcd_refresh = 0x0d2a ;
    _lcd_power_on = 0x0d5a ;
    _lcd_power_off = 0x0d6c ;
    _lcd_init = 0x0d88 ;
    _rx_handler = 0x0dd2 ;
    _rx_core = 0x0de6 ;
    _rxerror_handler = 0x0e52 ;
    _rxerror_core = 0x0e66 ;
    _txend_handler = 0x0eac ;
    _txend_core = 0x0ec0 ;
    _tx_handler = 0x0ece ;
    _tx_core = 0x0ee2 ;
    _lnp_logical_shutdown = 0x0f0a ;
    _lnp_logical_init = 0x0f2a ;
    _lnp_logical_write = 0x0fde ;
    _lnp_integrity_write = 0x108e ;
    _lnp_addressing_write = 0x10e6 ;
    _lnp_receive_packet = 0x1160 ;
    _lnp_integrity_byte = 0x11ec ;
    _lnp_integrity_reset = 0x12a4 ;
    _lnp_integrity_reset_core = 0x12b8 ;
    _lnp_timeout_reset = 0x12e4 ;
    _lnp_timeout_reset_core = 0x12f8 ;
    _lnp_init = 0x1302 ;
    _lnp_integrity_active = 0x131c ;
    _lnp_timeout_set = 0x1328 ;
    _program_valid = 0x1332 ;
    _key_handler = 0x167c ;
    _program_init = 0x1820 ;
    _program_shutdown = 0x1868 ;
    _vis_handler = 0x1872 ;
    _vis_core = 0x1886 ;
    _get_battery_mv = 0x18de ;
    _battery_refresh = 0x1908 ;
    _battery_refresh_core = 0x191c ;
    _shutoff_restart = 0x1946 ;
    _shutoff_init = 0x1956 ;
    _autoshutoff_check = 0x1962 ;
    _autoshutoff_check_core = 0x1976 ;
    _dkey_handler = 0x19a8 ;
    _dkey_pressed = 0x19e6 ;
    _dkey_released = 0x1a08 ;
    _getchar = 0x1a28 ;
    _dm_handler = 0x1a52 ;
    _dm_init = 0x1a90 ;
    _dm_shutdown = 0x1a94 ;
    _motor_a_dir = 0x1ab8 ;
    _motor_b_dir = 0x1af6 ;
    _motor_c_dir = 0x1b38 ;
    _ds_rotation_set = 0x1b7c ;
    _ds_rotation_handler = 0x1bd0 ;
    _ds_init = 0x1cc0 ;
    _ds_shutdown = 0x1cf6 ;
    _dsound_handler = 0x1d10 ;
    _dsound_core = 0x1d24 ;
    _dsound_init = 0x1e1c ;
    _dsound_shutdown = 0x1e34 ;
    _dsound_stop = 0x1e38 ;
    _dsound_finished = 0x1e58 ;
    _memset = 0x1e72 ;
    _memcpy = 0x1e80 ;
    ___mulhi3 = 0x1e92 ;
    ___mulsi3 = 0x1ea2 ;
    ___divsi3 = 0x1ebe ;
    _hex_display_codes = 0x1efc ;
    _ascii_display_codes = 0x1f0c ;
    _min_length = 0x1f9e ;
    _dm_a_pattern = 0x1fba ;
    _dm_b_pattern = 0x1fbe ;
    _dm_c_pattern = 0x1fc2 ;
    _firmware_string = 0x20a4 ;
    _etext = 0x20a4 ;
    _lcd_refresh_period = 0x20a8 ;
    _lnp_timeout = 0x20aa ;
    _vis_refresh_counter = 0x20ac ;
    _vis_refresh_period = 0x20ad ;
    _battery_refresh_counter = 0x20ae ;
    _battery_refresh_period = 0x20b0 ;
    _auto_shutoff_counter = 0x20b2 ;
    _auto_shutoff_period = 0x20b4 ;
    _auto_shutoff_secs = 0x20b6 ;
    _auto_shutoff_elapsed = 0x20b8 ;
    _idle_powerdown = 0x20ba ;
    _dsound_system_sounds = 0x20bc ;
    __edata = 0x20be ;
    _bss_start = 0x20c0 ;
    _mm_semaphore = 0x24a8 ;
    _mm_first_free = 0x24aa ;
    _tm_timeslice = 0x24ac ;
    _tm_current_slice = 0x24ad ;
    _tm_switcher_vector = 0x24ae ;
    _sys_time = 0x24b0 ;
    _pd_idle = 0x24c0 ;
    _cpid = 0x24c2 ;
    _nb_tasks = 0x24c4 ;
    _priority_head = 0x24c6 ;
    _pd_single = 0x24d0 ;
    _task_sem = 0x24e4 ;
    _lcd_byte_counter = 0x24e6 ;
    _lcd_refresh_counter = 0x24e7 ;
    _tx_state = 0x24e8 ;
    _tx_sem = 0x24e9 ;
    _lnp_integrity_handler = 0x24f0 ;
    _lnp_timeout_counter = 0x24f2 ;
    _lnp_addressing_handler = 0x2500 ;
    _lnp_integrity_state = 0x2520 ;
    _packet_len = 0x2522 ;
    _cprog = 0x2524 ;
    _packet_src = 0x2526 ;
    _dkey_timer = 0x2528 ;
    _dkey = 0x2529 ;
    _dkey_multi = 0x252a ;
    _dm_a = 0x252c ;
    _dm_b = 0x2530 ;
    _dm_c = 0x2534 ;
    _ds_rotation = 0x2538 ;
    _ds_channel = 0x2539 ;
    _ds_rotations = 0x2540 ;
    _ds_activation = 0x2546 ;
    _dsound_next_note = 0x2548 ;
    _dsound_internote_ms = 0x254a ;
    _dsound_16th_ms = 0x254c ;
    _dsound_next_time = 0x2550 ;
    _end = 0x2554 ;
    _mm_start = 0x2554 ;
    /* end of kernel symbols */
  }  > kern
      
  .text BLOCK(2) :	{
    ___text = . ;
    *(.text) 	      /* must start with text for clean entry */			
    *(.rodata)
    *(.strings)
    *(.vectors)       /* vectors region (dummy) */
    *(.persist)

    ___text_end = . ;
  }  > ram

  .tors BLOCK(2) : {
    ___ctors = . ;
    *(.ctors)
    ___ctors_end = . ;
    ___dtors = . ;
    *(.dtors)
    ___dtors_end = . ;
  }  > ram

  .data BLOCK(2) : {
    ___data = . ;
    *(.data)
    *(.tiny)
    ___data_end = . ;
  }  > ram

  .bss BLOCK(2) : {
    ___bss = . ;
    *(.bss)
    *(COMMON)
    ___bss_end = ALIGN(2) ;
  }  >ram

  .stack : {
    _stack = . ; 
    *(.stack)
  }  > topram

  .eight 0xff00: {
    *(.eight)

    /* on-chip module registers (relative to 0xff00) */

    _T_IER = 0x90 ;
    _T_CSR = 0x91 ;
    _T_CNT = 0x92 ;
    _T_OCRA = 0x94 ;
    _T_OCRB = 0x94 ;
    _T_CR = 0x96 ;
    _T_OCR = 0x97 ;
    _T_ICRA = 0x98 ;
    _T_ICRB = 0x9a ;
    _T_ICRC = 0x9c ;
    _T_ICRD = 0x9e ;
    _PORT1_PCR = 0xac ;
    _PORT2_PCR = 0xad ;
    _PORT3_PCR = 0xae ;
    _PORT1_DDR = 0xb0 ;
    _PORT2_DDR = 0xb1 ;
    _PORT1 = 0xb2 ;
    _PORT2 = 0xb3 ;
    _PORT3_DDR = 0xb4 ;
    _PORT4_DDR = 0xb5 ;
    _PORT3 = 0xb6 ;
    _PORT4 = 0xb7 ;
    _PORT5_DDR = 0xb8 ;
    _PORT6_DDR = 0xb9 ;
    _PORT5 = 0xba ;
    _PORT6 = 0xbb ;
    _PORT7 = 0xbe ;
    _STCR = 0xc3 ;
    _SYSCR = 0xc4 ;
    _T0_CR = 0xc8 ;
    _T0_CSR = 0xc9 ;
    _T0_CORA = 0xca ;
    _T0_CORB = 0xcb ;
    _T0_CNT = 0xcc ;
    _T1_CR = 0xd0 ;
    _T1_CSR = 0xd1 ;
    _T1_CORA = 0xd2 ;
    _T1_CORB = 0xd3 ;
    _T1_CNT = 0xd4 ;
    _S_MR = 0xd8 ;
    _S_BRR = 0xd9 ;
    _S_CR = 0xda ;
    _S_TDR = 0xdb ;
    _S_SR = 0xdc ;
    _S_RDR = 0xdd ;
    _AD_A = 0xe0 ;
    _AD_A_H = 0xe0 ;
    _AD_A_L = 0xe1 ;
    _AD_B = 0xe2 ;
    _AD_B_H = 0xe2 ;
    _AD_B_L = 0xe3 ;
    _AD_C = 0xe4 ;
    _AD_C_H = 0xe4 ;
    _AD_C_L = 0xe5 ;
    _AD_D = 0xe6 ;
    _AD_D_H = 0xe6 ;
    _AD_D_L = 0xe7 ;
    _AD_CSR = 0xe8 ;
    _AD_CR = 0xe9 ;
    
    /* end of on-chip module registers */
    
  }  > eight

  .stab 0 (NOLOAD) : {
    [ .stab ]
  }

  .stabstr 0 (NOLOAD) : {
    [ .stabstr ]
  }

} /* SECTIONS */
